import { ElementRef, OnInit, OnDestroy, QueryList, Renderer2 } from '@angular/core';
import { OpenViduInternalComponent, ToolbarOption } from '../openvidu-internal/openvidu-internal.component';
import { MatSidenav } from '@angular/material';
import { BigScreenService } from 'angular-bigscreen';
import { CameraAccessEvent, ParticipantEvent, StreamEvent } from '../openvidu.directive';
import { StreamAppearinComponent } from './stream-appearin/stream-appearin.component';
import { OpenViduAppearinIntl } from './openvidu-appearin-intl';
export declare class OpenViduAppearinComponent extends OpenViduInternalComponent implements OnInit, OnDestroy {
    private renderer;
    private bigScreenService;
    _intl: OpenViduAppearinIntl;
    toolbarOptions: ToolbarOption[];
    mainElement: ElementRef;
    sidenav: MatSidenav;
    messageInput: ElementRef;
    panelVideo: ElementRef;
    streamAppearin: QueryList<StreamAppearinComponent>;
    streamMaxWidth: string;
    streamMaxHeight: string;
    welcome: boolean;
    showChat: boolean;
    constructor(renderer: Renderer2, bigScreenService: BigScreenService, _intl: OpenViduAppearinIntl);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onResize(): void;
    toggleMic(): void;
    toggleCamera(): void;
    toggleFullscreen(): void;
    toggleChat(): void;
    sendMessage(text: string): void;
    leaveRoom(callLeaveRoom?: boolean): void;
    handleOnServerConnected(): void;
    handleOnErrorRoom(): void;
    handleOnCameraAccessChange(cameraEvent: CameraAccessEvent): void;
    handleOnParticipantJoined(participantEvent: ParticipantEvent): void;
    handleOnParticipantLeft(participantEvent: ParticipantEvent): void;
    handleOnStreamAdded(streamEvent: StreamEvent): void;
    handleOnStreamRemoved(streamEvent: StreamEvent): void;
    handleOnSourceAdded(): void;
    private resizeStreamsManually();
}
