import { ElementRef, OnInit, OnDestroy, QueryList, Renderer2 } from '@angular/core';
import { OpenViduInternalComponent, ToolbarOption } from '../openvidu-internal/openvidu-internal.component';
import { MatSidenav } from '@angular/material';
import { BigScreenService } from 'angular-bigscreen';
import { CameraAccessEvent, ParticipantEvent, StreamEvent } from '../openvidu.directive';
import { StreamGoToMeetingComponent } from './stream-gotomeeting/stream-gotomeeting.component';
import { OpenViduGoToMeetingIntl } from './openvidu-gotomeeting-intl';
export declare class OpenViduGoToMeetingComponent extends OpenViduInternalComponent implements OnInit, OnDestroy {
    private renderer;
    private bigScreenService;
    _intl: OpenViduGoToMeetingIntl;
    toolbarOptions: ToolbarOption[];
    showSecondaryContent: boolean;
    mainElement: ElementRef;
    sidenav: MatSidenav;
    messageInput: ElementRef;
    panelVideo: ElementRef;
    streamGoToMeeting: QueryList<StreamGoToMeetingComponent>;
    streamMaxWidth: string;
    streamMaxHeight: string;
    welcome: boolean;
    showChat: boolean;
    showPeople: boolean;
    JSON: any;
    constructor(renderer: Renderer2, bigScreenService: BigScreenService, _intl: OpenViduGoToMeetingIntl);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onResize(): void;
    toggleMic(): void;
    toggleCamera(): void;
    togglePeople(): void;
    toggleChat(): void;
    toggleFullscreen(): void;
    onSidenavCloseStart(): void;
    onChangeSplitPane(): void;
    sendMessage(text: string): void;
    leaveRoom(callLeaveRoom?: boolean): void;
    handleOnServerConnected(): void;
    handleOnErrorRoom(): void;
    handleOnCameraAccessChange(cameraEvent: CameraAccessEvent): void;
    handleOnParticipantJoined(participantEvent: ParticipantEvent): void;
    handleOnParticipantLeft(participantEvent: ParticipantEvent): void;
    handleOnStreamAdded(streamEvent: StreamEvent): void;
    handleOnStreamRemoved(streamEvent: StreamEvent): void;
    handleOnSourceAdded(): void;
    private resizeStreamsManually();
}
