"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var openvidu_gotomeeting_intl_1 = require("../openvidu-gotomeeting-intl");
var stream_internal_component_1 = require("../../openvidu-internal/stream-internal.component");
var safe_url_pipe_1 = require("../../utils/safe-url.pipe");
var StreamGoToMeetingComponent = (function (_super) {
    __extends(StreamGoToMeetingComponent, _super);
    function StreamGoToMeetingComponent(safeUrlPipe, renderer, _intl) {
        var _this = _super.call(this, safeUrlPipe, renderer) || this;
        _this.safeUrlPipe = safeUrlPipe;
        _this.renderer = renderer;
        _this._intl = _intl;
        return _this;
    }
    StreamGoToMeetingComponent.prototype.setStreamCallback = function (val) {
        // If local, show nice name
        var dataObj = JSON.parse(this.stream.getParticipant().data);
        this.name.nativeElement.textContent = (this.stream.isLocalMirrored()) ? this._intl.you : dataObj.username;
    };
    __decorate([
        core_1.ViewChild('name'),
        __metadata("design:type", core_1.ElementRef)
    ], StreamGoToMeetingComponent.prototype, "name", void 0);
    __decorate([
        core_1.ViewChild('videoStream'),
        __metadata("design:type", core_1.ElementRef)
    ], StreamGoToMeetingComponent.prototype, "videoStream", void 0);
    StreamGoToMeetingComponent = __decorate([
        core_1.Component({
            selector: 'stream-gotomeeting',
            styles: ["\n   .flip-screen {\n     -webkit-transform: scaleX(-1);\n         -ms-transform: scaleX(-1);\n             transform: scaleX(-1); }\n\n   :host(stream-gotomeeting) {\n     display: -webkit-box;\n     display: -webkit-flex;\n     display: -ms-flexbox;\n     display: flex; }\n     :host(stream-gotomeeting) .participant {\n       -webkit-box-flex: 1;\n       -webkit-flex: 1;\n           -ms-flex: 1;\n               flex: 1;\n       width: 100%;\n       background-color: rgba(0, 0, 0, 0.4);\n       display: -webkit-box;\n       display: -webkit-flex;\n       display: -ms-flexbox;\n       display: flex;\n       -webkit-box-orient: vertical;\n       -webkit-box-direction: normal;\n       -webkit-flex-direction: column;\n           -ms-flex-direction: column;\n               flex-direction: column;\n       -webkit-box-pack: center;\n       -webkit-justify-content: center;\n           -ms-flex-pack: center;\n               justify-content: center;\n       -webkit-box-align: center;\n       -webkit-align-items: center;\n           -ms-flex-align: center;\n               align-items: center; }\n       :host(stream-gotomeeting) .participant span {\n         color: #fff;\n         display: none; }\n       :host(stream-gotomeeting) .participant video {\n         width: 100%;\n         height: 100%; }\n\t"],
            template: "\n\t\t<div class=\"participant\">\n\t\t\t<span #name></span>\n\t\t\t<video #videoStream autoplay=\"true\" [src]=\"videoSrc\" [muted]=\"muted\"></video>\n        </div>"
        }),
        __metadata("design:paramtypes", [safe_url_pipe_1.SafeUrlPipe, core_1.Renderer,
            openvidu_gotomeeting_intl_1.OpenViduGoToMeetingIntl])
    ], StreamGoToMeetingComponent);
    return StreamGoToMeetingComponent;
}(stream_internal_component_1.StreamInternalComponent));
exports.StreamGoToMeetingComponent = StreamGoToMeetingComponent;
