import { ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { ConnectionState, OpenViduInternalComponent, ToolbarOption } from '../openvidu-internal/openvidu-internal.component';
import { MatDialog, MatSidenav } from '@angular/material';
import { BigScreenService } from 'angular-bigscreen';
import { OpenViduHangoutsIntl } from './openvidu-hangouts-intl';
export declare class OpenViduHangoutsComponent extends OpenViduInternalComponent implements OnInit, OnDestroy {
    private renderer;
    private bigScreenService;
    _intl: OpenViduHangoutsIntl;
    dialog: MatDialog;
    toolbarOptions: ToolbarOption[];
    mainElement: ElementRef;
    sidenav: MatSidenav;
    messageInput: ElementRef;
    chatButtonState: string;
    connectionUiState: ConnectionState;
    JSON: any;
    constructor(renderer: Renderer2, bigScreenService: BigScreenService, _intl: OpenViduHangoutsIntl, dialog: MatDialog);
    ngOnInit(): void;
    ngOnDestroy(): void;
    toggleMic(): void;
    toggleCamera(): void;
    toggleFullscreen(): void;
    toggleChat(): void;
    openSettings(): void;
    onSidenavOpenStart(): void;
    onSidenavCloseStart(): void;
    sendMessage(text: string): void;
    leaveRoom(callLeaveRoom?: boolean): void;
    handleOnServerConnected(): void;
    handleOnErrorRoom(): void;
}
