"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var openvidu_hangouts_intl_1 = require("../openvidu-hangouts-intl");
var stream_internal_component_1 = require("../../openvidu-internal/stream-internal.component");
var safe_url_pipe_1 = require("../../utils/safe-url.pipe");
var StreamHangoutsComponent = (function (_super) {
    __extends(StreamHangoutsComponent, _super);
    function StreamHangoutsComponent(safeUrlPipe, renderer, _intl) {
        var _this = _super.call(this, safeUrlPipe, renderer) || this;
        _this.safeUrlPipe = safeUrlPipe;
        _this.renderer = renderer;
        _this._intl = _intl;
        return _this;
    }
    StreamHangoutsComponent.prototype.setStreamCallback = function (val) {
        // If local, show nice name
        var dataObj = JSON.parse(this.stream.getParticipant().data);
        this.name.nativeElement.textContent = (this.stream.isLocalMirrored()) ? this._intl.you : dataObj.username;
    };
    __decorate([
        core_1.ViewChild('name'),
        __metadata("design:type", core_1.ElementRef)
    ], StreamHangoutsComponent.prototype, "name", void 0);
    __decorate([
        core_1.ViewChild('videoStream'),
        __metadata("design:type", core_1.ElementRef)
    ], StreamHangoutsComponent.prototype, "videoStream", void 0);
    StreamHangoutsComponent = __decorate([
        core_1.Component({
            selector: 'stream-hangouts',
            styles: ["\n   .flip-screen {\n     -webkit-transform: scaleX(-1);\n         -ms-transform: scaleX(-1);\n             transform: scaleX(-1); }\n\n   :host(stream-hangouts).main-stream .participant {\n     width: 100%;\n     height: 100%;\n     margin: 0px;\n     float: none;\n     display: -webkit-box;\n     display: -webkit-flex;\n     display: -ms-flexbox;\n     display: flex; }\n     :host(stream-hangouts).main-stream .participant .name {\n       display: none; }\n     :host(stream-hangouts).main-stream .participant video {\n       width: 100%; }\n\n   :host(stream-hangouts).square .participant {\n     display: -webkit-box;\n     display: -webkit-flex;\n     display: -ms-flexbox;\n     display: flex;\n     -webkit-box-pack: center;\n     -webkit-justify-content: center;\n         -ms-flex-pack: center;\n             justify-content: center;\n     width: 100px;\n     overflow: hidden; }\n     :host(stream-hangouts).square .participant .name {\n       text-align: center;\n       top: 45px;\n       white-space: normal;\n       word-break: break-all; }\n     :host(stream-hangouts).square .participant video {\n       width: auto; }\n\n   :host(stream-hangouts).hide-video .participant .name {\n     text-align: center;\n     top: 45px;\n     white-space: normal;\n     word-break: break-all; }\n\n   :host(stream-hangouts).hide-video .participant video {\n     display: none; }\n\n   :host(stream-hangouts) .participant {\n     position: relative;\n     width: 177px;\n     height: 100px;\n     -webkit-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.4);\n             box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.4);\n     background-color: rgba(0, 0, 0, 0.4); }\n     :host(stream-hangouts) .participant .name {\n       position: absolute;\n       bottom: 10px;\n       -o-text-overflow: ellipsis;\n          text-overflow: ellipsis;\n       padding: 0px 10px;\n       color: #fff;\n       -webkit-box-sizing: border-box;\n               box-sizing: border-box;\n       text-shadow: #000 1px 1px 3px;\n       width: 100%;\n       overflow: hidden;\n       direction: ltr;\n       z-index: 1; }\n     :host(stream-hangouts) .participant .mic-off {\n       position: absolute;\n       bottom: 10px;\n       -o-text-overflow: ellipsis;\n          text-overflow: ellipsis;\n       padding: 0px 10px;\n       color: #fff;\n       -webkit-box-sizing: border-box;\n               box-sizing: border-box;\n       text-shadow: #000 1px 1px 3px;\n       width: 100%;\n       overflow: hidden;\n       direction: ltr;\n       z-index: 1;\n       text-align: center;\n       background: rgba(0, 0, 0, 0.5);\n       -webkit-border-radius: 50%;\n               border-radius: 50%;\n       width: 26px;\n       height: 26px;\n       padding: 4px;\n       right: 5px; }\n     :host(stream-hangouts) .participant .cam-off {\n       position: absolute;\n       -o-text-overflow: ellipsis;\n          text-overflow: ellipsis;\n       padding: 0px 10px;\n       color: #fff;\n       -webkit-box-sizing: border-box;\n               box-sizing: border-box;\n       text-shadow: #000 1px 1px 3px;\n       width: 100%;\n       overflow: hidden;\n       direction: ltr;\n       z-index: 1;\n       text-align: center;\n       background: rgba(0, 0, 0, 0.5);\n       -webkit-border-radius: 50%;\n               border-radius: 50%;\n       width: 26px;\n       height: 26px;\n       padding: 4px;\n       top: 10px;\n       right: 5px; }\n     :host(stream-hangouts) .participant video {\n       width: 100%;\n       height: 100%; }\n\t"],
            template: "\n\t\t<div class=\"participant\">\n\t\t\t<span #name class=\"name\"></span>\n\t\t\t<video #videoStream autoplay=\"true\" [src]=\"videoSrc\" [muted]=\"muted\"></video>\n        </div>"
        }),
        __metadata("design:paramtypes", [safe_url_pipe_1.SafeUrlPipe, core_1.Renderer,
            openvidu_hangouts_intl_1.OpenViduHangoutsIntl])
    ], StreamHangoutsComponent);
    return StreamHangoutsComponent;
}(stream_internal_component_1.StreamInternalComponent));
exports.StreamHangoutsComponent = StreamHangoutsComponent;
