"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
// OpenVidu Directive
var openvidu_directive_1 = require("./openvidu.directive");
var OpenViduHelperComponent = (function () {
    function OpenViduHelperComponent() {
        // Rest of peers
        this.streams = [];
    }
    Object.defineProperty(OpenViduHelperComponent.prototype, "openviduApi", {
        get: function () { return this._openviduApi; },
        set: function (openviduApi) {
            var _this = this;
            if (this._openviduApi || !openviduApi)
                return;
            this._openviduApi = openviduApi;
            this._openviduApi.onUpdateMainSpeaker.subscribe(function (streamEvent) {
                _this.handleOnUpdateMainSpeaker(streamEvent);
            });
            this._openviduApi.onCameraAccessChange.subscribe(function (cameraEvent) {
                _this.handleOnCameraAccessChange(cameraEvent);
            });
            this._openviduApi.onStreamAdded.subscribe(function (streamEvent) {
                _this.handleOnStreamAdded(streamEvent);
            });
            this._openviduApi.onStreamRemoved.subscribe(function (streamEvent) {
                _this.handleOnStreamRemoved(streamEvent);
            });
        },
        enumerable: true,
        configurable: true
    });
    /*------------------------*/
    /* HANDLE OPENVIDU EVENTS */
    /*------------------------*/
    OpenViduHelperComponent.prototype.handleOnUpdateMainSpeaker = function (streamEvent) {
        // Check if stream exists
        if (this.streams.indexOf(streamEvent.stream) < 0) {
            this.streams.push(streamEvent.stream);
        }
        // Set main stream
        this.mainStream = streamEvent.stream;
    };
    OpenViduHelperComponent.prototype.handleOnCameraAccessChange = function (cameraEvent) {
        if (cameraEvent.access) {
            // All good :)
            if (this.streams.indexOf(this.myCamera) < 0) {
                this.streams.push(this.myCamera);
            }
        }
        else if (!cameraEvent.access) {
            // No camera :(
        }
    };
    OpenViduHelperComponent.prototype.handleOnStreamAdded = function (streamEvent) {
        var newStream = streamEvent.stream;
        if (this.streams.indexOf(newStream) < 0) {
            this.streams.push(newStream);
        }
    };
    OpenViduHelperComponent.prototype.handleOnStreamRemoved = function (streamEvent) {
        var oldStream = streamEvent.stream;
        this.streams.splice(this.streams.indexOf(oldStream), 1);
    };
    __decorate([
        core_1.ViewChild(openvidu_directive_1.OpenViduDirective),
        __metadata("design:type", openvidu_directive_1.OpenViduDirective),
        __metadata("design:paramtypes", [openvidu_directive_1.OpenViduDirective])
    ], OpenViduHelperComponent.prototype, "openviduApi", null);
    return OpenViduHelperComponent;
}());
exports.OpenViduHelperComponent = OpenViduHelperComponent;
