"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
// Stream object
var openvidu_browser_1 = require("openvidu-browser");
var StreamInternalComponent = (function () {
    function StreamInternalComponent(safeUrlPipe, renderer) {
        this.safeUrlPipe = safeUrlPipe;
        this.renderer = renderer;
        this.onSourceAdded = new core_1.EventEmitter();
    }
    Object.defineProperty(StreamInternalComponent.prototype, "stream", {
        get: function () { return this._stream; },
        set: function (val) {
            var _this = this;
            if (val === null || val === undefined)
                return;
            this._stream = val;
            // Loop until you get a WrStream
            var int = setInterval(function () {
                if (_this.stream.getWrStream()) {
                    _this.videoSrc = _this.safeUrlPipe.transform(_this.stream.getVideoSrc());
                    console.log('Video tag src = ' + _this.videoSrc);
                    clearInterval(int);
                    // Fix: manually call OnInit
                    _this.ngOnInit();
                }
            }, 1000);
            // If local, mute video
            this.muted = this.stream.isLocalMirrored();
            // If local, flip screen
            this.renderer.setElementClass(this.videoStream.nativeElement, 'flip-screen', this.stream.isLocalMirrored());
            this.setStreamCallback(val);
            // If local, show nice name
            //let dataObj: ParticipantData = JSON.parse(this.stream.getParticipant().data);
            //this.name.nativeElement.textContent = (this.stream.isLocalMirrored()) ? this._intl.you : dataObj.username;
        },
        enumerable: true,
        configurable: true
    });
    StreamInternalComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.videoStream.nativeElement.addEventListener('loadeddata', function () {
            // Emit event
            _this.onSourceAdded.emit();
        }, false);
        if (!this.stream)
            return;
        // Listen for changes in the src
        // For example, if the participants wants to change camera
        this.stream.addEventListener('src-added', function () {
            _this.videoSrc = _this.safeUrlPipe.transform(_this.stream.getVideoSrc());
        });
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], StreamInternalComponent.prototype, "onSourceAdded", void 0);
    __decorate([
        core_1.Input('stream'),
        __metadata("design:type", openvidu_browser_1.Stream),
        __metadata("design:paramtypes", [openvidu_browser_1.Stream])
    ], StreamInternalComponent.prototype, "stream", null);
    return StreamInternalComponent;
}());
exports.StreamInternalComponent = StreamInternalComponent;
